﻿package  {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Hud extends Actor {
		var res:Array = new Array;
		var pan:int = 0;
		
		public function Hud() {
			AddToLayer(g.layerUI);
			AddEventListener(GEvent.Tick, Tick);
			Set(res2, T.res_water);
			Set(res1, T.res_vitamin);
			Set(res3, T.res_sun);
			Set(res4, T.res_co2);
			Set(res5, T.res_fame);
			Set(res6, T.res_sugar);
			
			surfButtonUp.gotoAndStop(1);
			surfButtonUp.buttonMode = true;
			surfButtonUp.addEventListener(MouseEvent.CLICK, UpClick, false, 0, true);
			surfButtonUp.addEventListener(MouseEvent.ROLL_OVER, UpRollOver, false, 0, true);
			surfButtonUp.addEventListener(MouseEvent.ROLL_OUT, UpRollOut, false, 0, true);
			
			surfButtonDown.gotoAndStop(1);
			surfButtonDown.buttonMode = true;
			surfButtonDown.addEventListener(MouseEvent.CLICK, DownClick, false, 0, true);
			surfButtonDown.addEventListener(MouseEvent.ROLL_OVER, DownRollOver, false, 0, true);
			surfButtonDown.addEventListener(MouseEvent.ROLL_OUT, DownRollOut, false, 0, true);
			
			twitter.buttonMode = true;
			twitter.gotoAndStop(1);
			twitter.addEventListener(MouseEvent.ROLL_OVER, TwitterRollOver, false, 0, true);
			twitter.addEventListener(MouseEvent.ROLL_OUT, TwitterRollOut, false, 0, true);
			twitter.addEventListener(MouseEvent.CLICK, TwitterClick, false, 0, true);
			
			endDay.gotoAndStop(1);
			endDay.buttonMode = true;
			endDay.addEventListener(MouseEvent.ROLL_OVER, EndDayRollOver, false, 0, true);
			endDay.addEventListener(MouseEvent.ROLL_OUT, EndDayRollOut, false, 0, true);
			endDay.addEventListener(MouseEvent.CLICK, EndDayClick, false, 0, true);
			
			weeds.visible = false;
			bugsHaveGrown.visible = false;
			cannotAfford.visible = false;
			
			//dbg.visible = false;
			//dbg.addEventListener(MouseEvent.CLICK, DebugClick, false, 0, true);
			
			Update();
		}
		
		public function TwitterRollOver(e:MouseEvent):void {
			AA.Play(AA.hover);
			twitter.gotoAndStop(2);
		}
		
		public function TwitterRollOut(e:MouseEvent):void {
			twitter.gotoAndStop(1);
		}
		
		public function TwitterClick(e:MouseEvent):void {
			T.OpenURL(T.url_twitter);
			AA.Play(AA.mousepop);
		}
		
		public function CannotAfford():void {
			cannotAfford.visible = true;
			cannotAfford.gotoAndPlay(1);
		}
		
		public function WeedsHaveGrown():void {
			weeds.gotoAndPlay(1);
			weeds.visible = true;
		}
		
		public function PestsHaveGrown():void {
			bugsHaveGrown.gotoAndPlay(1);
			bugsHaveGrown.visible = true;
		}
		
		public function EndDayRollOver(e:MouseEvent):void {
			AA.Play(AA.hover);
			endDay.gotoAndStop(2);
		}
		
		public function EndDayRollOut(e:MouseEvent):void {
			endDay.gotoAndStop(1);
		}
		
		public function EndDayClick(e:MouseEvent):void {
			g.EndDay();
			AA.Play(AA.mousepop);
		}
		
		public function Set(_resource:MovieClip, _type:Object):void {
			var obj:Object = new Object;
			obj.res = _resource;
			obj.type = _type;
			_resource.icon.gotoAndStop(_type.frame);
			_resource.mouseEnabled = true;
			_resource.mouseChildren = true;
			_resource.addEventListener(MouseEvent.ROLL_OVER, ResRollOver, false, 0, true);
			_resource.addEventListener(MouseEvent.ROLL_OUT, ResRollOut, false, 0, true);
			res.push(obj);
		}
		
		public function ResRollOver(e:MouseEvent):void {
			AA.Play(AA.hover);
			if (e.target == res1)
				g.popup.Show(4);
			else if (e.target == res2)
				g.popup.Show(3);
			else if (e.target == res3)
				g.popup.Show(5);
			else if (e.target == res4)
				g.popup.Show(6);
			else if (e.target == res5)
				g.popup.Show(7);
			else if (e.target == res6)
				g.popup.Show(8);
		}
		
		public function ResRollOut(e:MouseEvent):void {
			g.popup.Hide();
		}
		
		public function DebugClick(e:MouseEvent):void {
			g.roots.Step();
			g.pumpkin.Grow();
			g.bg.GrowWeeds();
			g.CheckLeafs();
		}
		
		public function DownClick(e:MouseEvent):void {
			g.SetCam(g.camy1 - 100, false);
			AA.Play(AA.mousepop);
		}
		
		public function DownRollOver(e:MouseEvent):void {
			surfButtonDown.gotoAndStop(2);
			AA.Play(AA.hover);
		}
		
		public function DownRollOut(e:MouseEvent):void {
			surfButtonDown.gotoAndStop(1);
		}
		
		public function UpClick(e:MouseEvent):void {
			g.SetCam(g.camy1 + 100, false);
			AA.Play(AA.mousepop);
		}
		
		public function UpRollOver(e:MouseEvent):void {
			surfButtonUp.gotoAndStop(2);
			AA.Play(AA.hover);
		}
		
		public function UpRollOut(e:MouseEvent):void {
			surfButtonUp.gotoAndStop(1);
		}
		
		/*
		public function UpClick(e:MouseEvent):void {
			//++pan %= Game.camPans.length;
			pan++;
			if (pan >= Game.camPans.length)
				pan = 0;
			g.SetCam(Game.camPans[pan], false);
			g.SetFocus();
		}
		
		public function SurfRollOver(e:MouseEvent):void {
			
		}
		
		public function SurfRollOut(e:MouseEvent):void {
			
		}
		*/
		
		public function Update():void {
			currDay.text.width = 180;
			currDay.text.text = "Day " + g.day + " of " + T.maxDays;
			
			// res amounts
			var i:int;
			for (i = 0; i < res.length; i++) {
				var obj:Object = res[i] as Object;
				obj.res.digits.text.text = g.res[obj.type.index];
			}
		}
		
		public function Tick(e:GEvent):void {
			
		}
	}
}































