package  {
	import flash.display.Stage;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	public class Keys {
		var arrKeys:Array = new Array;
		var stage:Stage = null;
		static const MaxKeys:int		= 256;
		
		static const key_up:int			= 38;
		static const key_down:int			= 40;
		static const key_left:int			= 37;
		static const key_right:int			= 39;
		static const key_escape:int		= 27;
		static const key_spacebar:int		= 32;
		
		static const key_a:int				= 65;
		static const key_b:int				= 66;
		static const key_c:int				= 67;
		static const key_d:int				= 68;
		static const key_e:int				= 69;
		static const key_f:int				= 70;
		static const key_g:int				= 71;
		static const key_h:int				= 72;
		static const key_i:int				= 73;
		static const key_j:int				= 74;
		static const key_k:int				= 75;
		static const key_l:int				= 76;
		static const key_m:int				= 77;
		static const key_n:int				= 78;
		static const key_o:int				= 79;
		static const key_p:int				= 80;
		static const key_q:int				= 81;
		static const key_r:int				= 82;
		static const key_s:int				= 83;
		static const key_t:int				= 84;
		static const key_u:int				= 85;
		static const key_v:int				= 86;
		static const key_w:int				= 87;
		static const key_x:int				= 88;
		static const key_y:int				= 89;
		static const key_z:int				= 90;
		
		static const key_0:int				= 48;
		static const key_1:int				= 49;
		static const key_2:int				= 50;
		static const key_3:int				= 51;
		static const key_4:int				= 52;
		static const key_5:int				= 53;
		static const key_6:int				= 54;
		static const key_7:int				= 55;
		static const key_8:int				= 56;
		static const key_9:int				= 57;
		
		public function Keys(_stage:Stage) {
			stage = _stage;
			var i:int;
			for (i = 0; i < MaxKeys; i++)
				arrKeys.push({down:false, prev:false, first:false});
			stage.addEventListener(KeyboardEvent.KEY_DOWN, e_keyDown, false, 0, true);
			stage.addEventListener(KeyboardEvent.KEY_UP, e_keyUp, false, 0, true);
		}
		
		public function Tick():void {
			var i:int;
			for (i = 0; i < MaxKeys; i++) {
				var key:Object = arrKeys[i];
				key.first = key.down && !key.prev;
				key.prev = key.down;
			}
		}
		
		public function keyDown(_keycode:int):Boolean {
			var key:Object = arrKeys[_keycode];
			return key.down;
		}
		
		public function keyTapped(_keycode:int):Boolean {
			var key:Object = arrKeys[_keycode];
			return key.first;
		}
		
		public function ValidKey(_keycode:int):Boolean {
			return (_keycode >= 0 && _keycode <= 256);
		}
		
		private function e_keyUp(e:KeyboardEvent):void {
			if (ValidKey(e.keyCode)) {
				var key:Object = arrKeys[e.keyCode];
				key.down = false;
				key.first = false;
			}
		}
		
		private function e_keyDown(e:KeyboardEvent):void {
			if (ValidKey(e.keyCode)) {
				var key:Object = arrKeys[e.keyCode];
				key.down = true;
			}
		}
	}
}





































