﻿package  {
	import fl.transitions.easing.None;
	import fl.transitions.easing.Regular;
	import fl.transitions.Transition;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Clipboard extends Actor {
		var growWeeds:Boolean = false;
		var infect:Boolean = false;
		var nextBuy:Number = 0;
		var yesDown:Boolean = false;
		var tut:Boolean = false;
		
		public function Clipboard(_tut:Boolean = false) {
			tut = _tut;
			g.fullScreen.visible = true;
			var i:int;
			if (tut) {
				gotoAndStop(7);
				journal1.text = "The local county fair is in " + T.maxDays + " days. I need to grow the heaviest pumpkin to win the blue ribbon!!";
			}
			else {
				AA.Play(AA.pour);
				gotoAndStop(1);
				amount1.text = g.resGainedToday[0];
				amount2.text = g.resGainedToday[1];
				amount3.text = g.resGainedToday[2];
				amount4.text = g.resGainedToday[3];
				amount5.text = g.resGainedToday[4];
				
				for (i = 0; i < 5; i++) {
					var res:MovieClip = Misc.FindMovieClip(this, "res" + (i + 1));
					res.gotoAndStop(T.res[i].frame);
					res.getChildAt(0).addEventListener(MouseEvent.ROLL_OVER, ResRollOver, false, 0, true);
					res.getChildAt(0).addEventListener(MouseEvent.ROLL_OUT, ResRollOut, false, 0, true);
				}
				
				// do not grow weeds immediately
				growWeeds = g.day >= 2;
				infect = g.day >= 3;
			}
			x = 947;
			y = 417;
			nextButton.gotoAndStop(1);
			nextButton.buttonMode = true;
			nextButton.addEventListener(MouseEvent.ROLL_OVER, NextButtonRollOver, false, 0, true);
			nextButton.addEventListener(MouseEvent.ROLL_OUT, NextButtonRollOut, false, 0, true);
			nextButton.addEventListener(MouseEvent.CLICK, NextButtonClick, false, 0, true);
			/*
			res1.gotoAndStop(T.res[0].frame);
			res2.gotoAndStop(T.res[1].frame);
			res3.gotoAndStop(T.res[2].frame);
			res4.gotoAndStop(T.res[3].frame);
			res5.gotoAndStop(T.res[4].frame);*/
			Misc.NewTween(new Tween(this, "x", Regular.easeOut, x, 653, 1.0, true));
			
			AddEventListener(GEvent.Tick, Tick);
			AddToLayer(g.layerUI);
		}
		
		public function Tick(e:GEvent):void {
			if ((currentFrame == 6 || currentFrame == 10 || currentFrame == 11) && x >= 945) {
				Kill();
				g.fullScreen.visible = false;
				g.GoodMorning(growWeeds, infect);
				if (currentFrame == 11) {
					new Picture;
				}
			}
			
			if (yesDown) {
				if (nextBuy < g.time) {
					// create sugar
					if (currentFrame == 2) {
						if (g.CanAfford(1, T.res_water) && g.CanAfford(1, T.res_sun) && g.CanAfford(1, T.res_co2)) {
							g.GiveRes(1, T.res_sugar);
							g.SpendRes(1, T.res_water);
							g.SpendRes(1, T.res_sun);
							g.SpendRes(1, T.res_co2);
						}
						else {
							g.hud.CannotAfford();
						}
					}
					// grow pumpkin
					else if (currentFrame == 3) {
						if (g.CanAfford(1, T.res_sun) && g.CanAfford(1, T.res_sugar) && g.CanAfford(1, T.res_vitamin)) {
							g.pumpkin.Grow();
							g.SpendRes(1, T.res_sun);
							g.SpendRes(1, T.res_sugar);
							g.SpendRes(1, T.res_vitamin);
							g.GiveRes(1, T.res_fame);
						}
						else {
							g.hud.CannotAfford();
						}
					}
					nextBuy = g.time + 0.05;
				}
			}
		}
		
		public function ResRollOver(e:MouseEvent):void {
			if (e.target as ResWater)
				g.popup.Show(3);
			else if (e.target as ResNutrients)
				g.popup.Show(4);
			else if (e.target as ResSun)
				g.popup.Show(5);
			else if (e.target as ResCO2)
				g.popup.Show(6);
			else if (e.target as ResFame)
				g.popup.Show(7);
			else if (e.target as ResSugar)
				g.popup.Show(8);
		}
		
		public function ResRollOut(e:MouseEvent):void {
			g.popup.Hide();
		}
		
		public function Next():void {
			var i:int;
			
			if (currentFrame == 4 && g.day == T.maxDays) {
				gotoAndStop(11);
				return;
			}
			else if (currentFrame == 11) {
				nextButton.mouseEnabled = false;
				Misc.NewTween(new Tween(this, "x", Regular.easeOut, 653, 947, 1.0, true));
				return;
			}
			
			if (currentFrame == 6 || currentFrame == 10) {
				nextButton.mouseEnabled = false;
				Misc.NewTween(new Tween(this, "x", Regular.easeOut, 653, 947, 1.0, true));
				return;
			}
			
			gotoAndStop(currentFrame + 1);
			
			for (i = 0; i < numChildren; i++) {
				// could've put these directly in the actual res classes oh well
				var ch:MovieClip = getChildAt(i) as MovieClip;
				if (ch as ResCO2 || ch as ResFame || ch as ResNutrients || ch as ResSugar || ch as ResSun || ch as ResWater) {
					ch.addEventListener(MouseEvent.ROLL_OVER, ResRollOver, false, 0, true);
					ch.addEventListener(MouseEvent.ROLL_OUT, ResRollOut, false, 0, true);
				}
			}
			
			// crate sugar? grow pumpkin?
			if (currentFrame == 2 || currentFrame == 3) {
				yesButton.buttonMode = true;
				yesButton.gotoAndStop(1);
				yesButton.addEventListener(MouseEvent.ROLL_OVER, YesButtonRollOver, false, 0, true);
				yesButton.addEventListener(MouseEvent.ROLL_OUT, YesButtonRollOut, false, 0, true);
				//yesButton.addEventListener(MouseEvent.CLICK, YesButtonClick, false, 0, true);
				yesButton.addEventListener(MouseEvent.MOUSE_DOWN, YesButtonDown, false, 0, true);
				yesButton.addEventListener(MouseEvent.MOUSE_UP, YesButtonUp, false, 0, true);
			}
			// weight
			else if (currentFrame == 4) {
				weight.text = "" + g.weight_kg + " kg!";
				weight_lbs.text = "(" + g.weight_lbs + " lbs)";
			}
			// spend points?
			else if (currentFrame == 5) {
				famecost.text.text = "Cost: " + g.fameCost;
				
				skill1.gotoAndStop(1);
				skill2.gotoAndStop(1);
				skill3.gotoAndStop(1);
				skill4.gotoAndStop(1);
				skill1.buttonMode = true;
				skill2.buttonMode = true;
				skill3.buttonMode = true;
				skill4.buttonMode = true;
				
				skill1.addEventListener(MouseEvent.ROLL_OVER, SkillRollOver, false, 0, true);
				skill1.addEventListener(MouseEvent.ROLL_OUT, SkillRollOut, false, 0, true);
				skill1.addEventListener(MouseEvent.CLICK, SkillClick, false, 0, true);
				
				skill2.addEventListener(MouseEvent.ROLL_OVER, SkillRollOver, false, 0, true);
				skill2.addEventListener(MouseEvent.ROLL_OUT, SkillRollOut, false, 0, true);
				skill2.addEventListener(MouseEvent.CLICK, SkillClick, false, 0, true);
				
				skill3.addEventListener(MouseEvent.ROLL_OVER, SkillRollOver, false, 0, true);
				skill3.addEventListener(MouseEvent.ROLL_OUT, SkillRollOut, false, 0, true);
				skill3.addEventListener(MouseEvent.CLICK, SkillClick, false, 0, true);
				
				skill4.addEventListener(MouseEvent.ROLL_OVER, SkillRollOver, false, 0, true);
				skill4.addEventListener(MouseEvent.ROLL_OUT, SkillRollOut, false, 0, true);
				skill4.addEventListener(MouseEvent.CLICK, SkillClick, false, 0, true);
			}
			else if (currentFrame == 6) {
				var daysTill:int = T.maxDays - g.day;
				if (daysTill <= 1) {
					tempjournal.text = "The local county fair is imminent!";
				}
				else {
					tempjournal.text = "The local county fair is in " + daysTill + " more days!";
				}
			}
		}
		
		public function YesButtonRollOver(e:MouseEvent):void {
			AA.Play(AA.hover);
			yesButton.gotoAndStop(2);
		}
		
		public function YesButtonRollOut(e:MouseEvent):void {
			yesButton.gotoAndStop(1);
			yesDown = false;
		}
		
		/*
		public function YesButtonClick(e:MouseEvent):void {
			if (nextBuy < g.time) {
				// create sugar
				if (currentFrame == 2) {
					if (g.CanAfford(1, T.res_water) && g.CanAfford(1, T.res_sun) && g.CanAfford(1, T.res_co2)) {
						g.GiveRes(1, T.res_sugar);
						g.SpendRes(1, T.res_water);
						g.SpendRes(1, T.res_sun);
						g.SpendRes(1, T.res_co2);
					}
					else {
						g.hud.CannotAfford();
					}
				}
				// grow pumpkin
				else if (currentFrame == 3) {
					if (g.CanAfford(1, T.res_sun) && g.CanAfford(1, T.res_sugar) && g.CanAfford(1, T.res_vitamin)) {
						g.pumpkin.Grow();
						g.SpendRes(1, T.res_sun);
						g.SpendRes(1, T.res_sugar);
						g.SpendRes(1, T.res_vitamin);
						g.GiveRes(1, T.res_fame);
					}
					else {
						g.hud.CannotAfford();
					}
				}
				nextBuy = g.time + 0.2;
			}
		}
		*/
		
		public function YesButtonUp(e:MouseEvent):void {
			yesDown = false;
		}
		
		public function YesButtonDown(e:MouseEvent):void {
			yesDown = true;
		}
		
		public function NextButtonRollOver(e:MouseEvent):void {
			AA.Play(AA.hover);
			nextButton.gotoAndStop(2);
		}
		
		public function NextButtonRollOut(e:MouseEvent):void {
			nextButton.gotoAndStop(1);
		}
		
		public function SkillRollOver(e:MouseEvent):void {
			AA.Play(AA.hover);
			e.target.gotoAndStop(2);
		}
		
		public function SkillRollOut(e:MouseEvent):void {
			e.target.gotoAndStop(1);
		}
		
		public function SkillClick(e:MouseEvent):void {
			if (g.CanAfford(g.fameCost, T.res_fame)) {
				AA.Play(AA.mousepop);
				
				if (e.target == skill1) {
					g.GiveRes(20, T.res_water);
					Next();
				}
				else if (e.target == skill2) {
					g.GiveRes(20, T.res_vitamin);
					Next();
				}
				else if (e.target == skill3) {
					g.bg.TrimWeeds();
					g.CheckLeafs();
					growWeeds = false; // don't grow immediately after trimming
					Next();
				}
				else if (e.target == skill4) {
					g.Pesticide();
					infect = false; // don't infect the day after spraying pesticide
					Next();
				}
				
				g.SpendRes(g.fameCost, T.res_fame);
				g.fameCost += 5;
			}
			else {
				g.hud.CannotAfford();
			}
		}
		
		public function NextButtonClick(e:MouseEvent):void {
			Next();
			AA.Play(AA.mousepop);
		}
	}
}

































