﻿package  {
	import fl.transitions.easing.None;
	import fl.transitions.easing.Regular;
	import fl.transitions.Transition;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Leaf extends Actor {
		var state:Boolean = false;
		
		public function Leaf(_x:Number, _y:Number) {
			x = _x;
			y = _y;
			rotation = Misc.Random(0, 36);
			AddToLayer(g.layerBack);
			AddToContainer(g.leafs);
			gotoAndStop(Misc.RandomInt(1, totalFrames));
			Toggle(true);
			leafBug.visible = false;
			
			Misc.NewTween(new Tween(this, "scaleX", Regular.easeOut, 0.1, 1.0, 0.8, true));
			Misc.NewTween(new Tween(this, "scaleY", Regular.easeOut, 0.1, 1.0, 0.8, true));
			Misc.NewTween(new Tween(this, "rotation", Regular.easeOut, rotation, rotation + Misc.Random(-45, 45), 0.8, true));
			
			g.CheckLeafs();
			AddToContainer(g.leafs);
			addEventListener(MouseEvent.ROLL_OVER, RollOver, false, 0, true);
			addEventListener(MouseEvent.ROLL_OUT, RollOut, false, 0, true);
		}
		
		public function RollOver(e:MouseEvent):void {
			// infections takes precendence
			if (leafBug.visible) {
				g.popup.Show(16);
			}
			else {
				if (state)
					g.popup.Show(15);
				else
					g.popup.Show(14);
			}
		}
		
		public function RollOut(e:MouseEvent):void {
			g.popup.Hide();
		}
		
		public function Toggle(_state:Boolean):void {
			state = _state;
			if (state)
				gotoAndStop(1);
			else
				gotoAndStop(2);
		}
	}
}
