﻿package  {
	import fl.transitions.easing.None;
	import fl.transitions.easing.Regular;
	import fl.transitions.Transition;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	public class Pumpkin extends MovieClip {
		var currScale:Number = 0;
		
		public function Pumpkin() {
			currScale = 0.1;
			scaleX = currScale;
			scaleY = currScale;
			//x = T.halfWidth;
			//y = T.ground;
			//AddToLayer(g.layerBack, 1);
			Grow(); // grow once, just for initial calculation
		}
		
		public function Grow():void {
			// sphere volume v = (4/3) pi r^3
			currScale += 0.02;
			
			var oldScale:Number = scaleX;
			var newScale:Number = currScale;
			scaleX = newScale;
			scaleY = newScale;
			var nextWidth:Number = width;
			// not necessarily using a particular unit, so as long as the
			// volume scales cubically based on the radius.
			var r:Number = (nextWidth * 0.5) * 0.0163198139813;
			var r3:Number = r * r * r;
			Actor.g.weight_kg = Math.ceil((4.0 / 3.0) * Math.PI * r3) as int;
			Actor.g.weight_lbs = Math.round(Actor.g.weight_kg * 2.20462) as int;
			
			scaleX = oldScale;
			scaleY = oldScale;
			Misc.NewTween(new Tween(this, "scaleX", Regular.easeOut, oldScale, currScale, 0.5, true));
			Misc.NewTween(new Tween(this, "scaleY", Regular.easeOut, oldScale, currScale, 0.5, true));
		}
	}
}










































